#include <bits/stdc++.h>
using namespace std;

int parent[1000001], size[1000001];

int root(int u) {
    if (u == parent[u]) return u;
    return parent[u] = root(parent[u]);
}

int allowed = 1, sum = 0;

multiset <int> bottom;
multiset <int> top;

template <class F> void output(multiset <F>& mst, int icr) {
    for (auto& x : mst) cout << x * icr << ' ';
}

void add_pq(int x) {
    if (top.size() < allowed) {
        top.insert(x);
        sum += x;

        return;
    }

    if ((*top.begin()) <= x) {
        int TOP = (*top.begin());
        top.erase(top.begin());
        bottom.insert(-TOP);
        sum -= TOP;
        top.insert(x);
        sum += x;

        return;
    }

    bottom.insert(-x);
}

void remove_pq(int x) {
    if ((*top.begin()) <= x) {
        top.erase(top.find(x));
        sum -= x;
        if (bottom.empty()) return;
        int y = -(*bottom.begin());
        bottom.erase(bottom.begin());
        add_pq(y);

        return;
    }

    bottom.erase(bottom.find(-x));
}

void connect(int u, int v) {
    u = root(u);
    v = root(v);

    if (u == v) {
        allowed++;

        int y = -(*bottom.begin());
        bottom.erase(bottom.begin());
        add_pq(y);

        return;
    }

    if (size[u] > size[v]) swap(u, v);

    remove_pq(size[u]);
    remove_pq(size[v]);

    parent[u] = v;
    size[v] += size[u];

    add_pq(size[v]);
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    for (int i = 1; i <= n; i++) {
        parent[i] = i;
        size[i] = 1;

        add_pq(1);
    }

    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        connect(a, b);

        /**cout << "allowed = " << allowed << '\n';
        output(bottom, -1);
        cout << '\n';
        output(top, 1);
        cout << "\n\n";*/
        cout << sum - 1 << '\n';
    }

    return 0;

}
