#include <bits/stdc++.h>
using namespace std;

struct Position{
    int x, y, dir;

    Position() {x = y = dir = 0;}
    Position(int z, int t) : x(z), y(t) {dir = 0;}

    void operator()(char ds) {
        if (ds == '+') dir++;
        if (ds == '-') dir--;

        if (ds == 'F') {
            dir %= 4;
            dir = (dir + 4) % 4;

            if (dir == 0) x--;
            else if (dir == 1) y--;
            else if (dir == 2) x++;
            else if (dir == 3) y++;
        }
    }

    int manhattan() {
        return abs(x) + abs(y);
    }

    void rotate() {
        dir++;
        int temp = x;
        x = -y;
        y = temp;
    }

    void rotate(int x) {
        while (x--) rotate();
    }
};

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    string s;
    cin >> s;

    int k;
    cin >> k;
    assert(k == 0);

    Position pos(0, 0);

    for (char ds : s) {
        pos(ds);
    }

    cout << pos.manhattan() << endl;
    return 0;

}
