#include <stdio.h>
using namespace std;

int l[1000001];
int siz[1000001];
int maxSize=0;

int leader(int x)
{
    if(l[x]==0)l[x]=x;
    if(x==l[x])return x;
    return l[x]=leader(l[x]);
}
void unite(int x,int y)
{
    if(leader(x)==leader(y))return;
    if(siz[l[x]]==0)siz[l[x]]=1;
    if(siz[l[y]]==0)siz[l[y]]=1;
    if(siz[l[x]]>siz[l[y]])
    {
        siz[l[x]]+=siz[l[y]];
        siz[l[y]]=0;
        if(siz[l[x]]>maxSize)maxSize=siz[l[x]];
        l[l[y]]=l[x];
    }
    else
    {
        siz[l[y]]+=siz[l[x]];
        siz[l[x]]=0;
        if(siz[l[y]]>maxSize)maxSize=siz[l[y]];
        l[l[x]]=l[y];
    }
}

int main()
{
    int n;
    int x,y;
    scanf("%d",&n);
    for(int i=0;i<n-1;i++)
    {
        scanf("%d",&x);
        scanf("%d",&y);
        unite(x,y);
        printf("%d\n",maxSize-1);
    }

    return 0;
}
