#include <iostream>
#include <vector>
using namespace std;
const int MOD = 1e9 + 7;

int main() {
    int N, M;
    cin >> N >> M;

    vector<long long> dp(N + 1, 0);
    vector<long long> sum(N + 1, 0);

    dp[0] = 1;
    sum[0] = 1;

    for (int i = 1; i <= N; ++i) {
        dp[i] = sum[i-1];

        for (int z = 2; z <= i; ++z) {
            dp[i] += dp[i / z];
            dp[i] %= M;
        }

        sum[i] = sum[i-1] + dp[i];
        sum[i] %= M;
    }

    cout << dp[N] << endl;

    return 0;
}
