#include <bits/stdc++.h>
using namespace std;

int parent[1000001], size[1000001];

int root(int u) {
    if (u == parent[u]) return u;
    return parent[u] = root(parent[u]);
}

void connect(int u, int v) {
    u = root(u);
    v = root(v);

    if (size[u] > size[v]) swap(u, v);

    parent[u] = v;
    if (u != v) size[v] += size[u];
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    for (int i = 1; i <= n; i++) {
        parent[i] = i;
        size[i] = 1;
    }

    int mx = 0;

    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;

        connect(a, b);
        mx = max(mx, size[root(a)] - 1);
        cout << mx << '\n';
    }

    return 0;

}
