#include <bits/stdc++.h>
using namespace std;

struct Position{
    int x, y;

    Position() {}
    Position(int z, int t) : x(z), y(t) {}

    void operator()(int dir) {
        dir %= 4;
        dir = (dir + 4) % 4;

        if (dir == 0) x++;
        else if (dir == 1) y++;
        else if (dir == 2) x--;
        else if (dir == 3) y--;

        //cout << x << ' ' << y << endl;
    }
};

struct State{
    Position pos;
    int dir;

    State() {}
    State(int x, int y, int z) : pos(x, y), dir(z) {}

    void execute(char ds) {
        if (ds == '+') dir++;
        if (ds == '-') dir--;
        if (ds == 'F') pos(dir);
    }
};

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    string s;
    cin >> s;

    int k;
    cin >> k;
    assert(k == 0);

    State pos(0, 0, 0);

    for (char& ds : s) {
        pos.execute(ds);
    }

    cout << abs(pos.pos.x) + abs(pos.pos.y) << endl;
    return 0;

}
