#include<iostream>
using namespace std;

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

struct DSU
{
    long long len, par;
};

long long n;
DSU a[1'000'003];

void input()
{
    cin>>n;
}

void precum()
{
    for (long long i=1; i<=n; i++)
    {
        a[i].len=1;
        a[i].par=i;
    }
}

long long findPar(long long x)
{
    if (x==a[x].par) return x;
    return a[x].par=findPar(a[x].par);
}
long long mx=1;
void conect(long long x, long long y)
{
    long long parx, pary;
    parx=findPar(x);
    pary=findPar(y);

    if (parx==pary) return;


    if (a[parx].len>a[pary].len)
    {
        a[parx].len+=a[pary].len;
        a[pary].par=parx;
    }
    else
    {
        a[pary].len+=a[parx].len;
        a[parx].par=pary;
    }

    mx=max(a[parx].len, mx);
    mx=max(a[pary].len, mx);
}



int main ()
{
    fastIO();
    input();
    precum();

    for (long long i=1; i<=n-1; i++)
    {
        long long x, y;
        cin>>x>>y;
        conect(x, y);
        cout<<mx-1<<'\n';
    }

    return 0;
}
