#include<bits/stdc++.h>
using namespace std;

int theChosenOne, p[1000001], sz[1000001];
bool left[1000001];

int root(int x)
{
    if(x == p[x]) return x;
    return p[x] = root(p[x]);
}

void dsu(int x, int y)
{
    x = root(x);
    y = root(y);
    if(x != y)
    {
        if(sz[x] < sz[y]) swap(x, y);
        p[y] = x;
        sz[x] += sz[y];
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    for(int i = 1; i <= n; i++)
    {
        p[i] = i;
        sz[i] = 1;
    }
    int a, b;
    cin>>a>>b;
    theChosenOne = a;
    dsu(a, b);
    cout<<"1\n";
    int ans = 0;
    for(int i = 1; i < n-1; i++)
    {
        cin>>a>>b;
        a = root(a);
        b = root(b);
        if(sz[a] < sz[b]) swap(a, b);
        if(a != theChosenOne && b != theChosenOne)
        {
            dsu(a, b);
        }
        else if((a == theChosenOne && b != theChosenOne) || (a != theChosenOne && b == theChosenOne))
        {
            dsu(a, b);
        }
        cout<<sz[theChosenOne]-1<<"\n";
    }
    return 0;
}
