#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <string>
#include <cstring>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#define endl '\n'
using namespace std;
int n, l[1000005], sz[1000005];
int find_leader(int x)
{
    if(l[x] == x)return x;
    return (l[x] = find_leader(l[x]));
}
int maxc = 0;
void connect(int x, int y)
{
    x = find_leader(x);
    y = find_leader(y);
     if(x == y)return;
    if(sz[x] < sz[y])swap(x, y);
    else{l[y] = x;
    sz[x] += sz[y];}
    if(sz[x] > maxc)maxc = sz[x];
}
void init()
{
    for(int i = 1; i <= n; i++)
    {
        l[i] = i;
        sz[i] = 1;
    }
}
void solve()
{
    cin >> n;
    init();
    int x, y;
    for(int i = 1; i < n; i++)
    {
        cin >> x >> y;
        connect(x, y);
        cout << maxc - 1 << endl;
    }
}
int main()
{
   ios_base::sync_with_stdio(false);
   cin.tie(0);
   cout.tie(0);
    solve();
   return 0;
}
