
#include <bits/stdc++.h>
using namespace std;

int main() {
    string commands;
    int K;
    cin >> commands >> K;

    int x = 0, y = 0;
    int direction = 0;

    for (char command : commands) {
        if (command == 'F') {
            if (direction == 0) x++;
            else if (direction == 1) y++;
            else if (direction == 2) x--;
            else y--;
        } else if (command == '+') {
            direction = (direction + 1) % 4;
        } else if (command == '-') {
            direction = (direction + 3) % 4;
        }
    }

    int initial_manhattan = abs(x) + abs(y);


    int f_count = 0;
    for (char command : commands) {
        if (command == 'F') f_count++;
    }


    int max_manhattan = 0;

    if (K == 0) {
        max_manhattan = initial_manhattan;
    } else if (K == 1) {
        max_manhattan = max(initial_manhattan, abs(x) + abs(y - 2));
        if (f_count > 0) {
            max_manhattan = max(max_manhattan, abs(x - 2) + abs(y));
        }
    } else if (K == 2) {
        max_manhattan = max(initial_manhattan, abs(x) + abs(y - 4));
        max_manhattan = max(max_manhattan, abs(x - 4) + abs(y));
        max_manhattan = max(max_manhattan, abs(x - 2) + abs(y - 2));
    }

    cout << max_manhattan << endl;

    return 0;
}
